<template>
  <form class="change-password" @submit.prevent="onChangePassword">
    <div>
      <div class="field">
        <input
          type="password"
          placeholder="Contraseña Actual"
          class="form-control input-sm"
          v-model="formData.password"
          :class="{ error: formError.password }"
        />
      </div>
      <div class="field">
        <input
          type="password"
          placeholder="Contraseña Nueva"
          class="form-control input-sm"
          v-model="formData.newPassword"
          :class="{ error: formError.newPassword }"
        />
      </div>
      <div class="field">
        <input
          type="password"
          placeholder="Repetir contraseña"
          class="form-control input-sm"
          v-model="formData.newPasswordRepeat"
          :class="{ error: formError.newPasswordRepeat }"
        />
      </div>
    </div>
    <button type="submit" class="btn btn-primary">Actualizar</button>
  </form>
</template>

<script>
import { ref } from "vue";
import * as Yup from "yup";
import { reauthenticate } from "../../utils/firebaseFunctions";
import { Auth } from "../../utils/firebase";

export default {
  name: "ChangePassword",

  setup() {
    let formData = {};
    let formError = ref({});
    let messageError = ref("");

    const schemaForm = Yup.object().shape({
      password: Yup.string().required(true),
      newPassword: Yup.string().required(true),
      newPasswordRepeat: Yup.string()
        .required(true)
        .oneOf([Yup.ref("newPassword")], true),
    });

    const onChangePassword = async () => {
      formError.value = {};
      messageError.value = "";

      try {
        await schemaForm.validate(formData, { abortEarly: false });
        console.log("Todo Ok");
        try {
          const { password, newPassword } = formData;
          await reauthenticate(password);
          await Auth.currentUser.updatePassword(newPassword);
          Auth.signOut();
        } catch (error) {
          console.log(error);
          messageError.value = error.message;
        }
      } catch (err) {
        err.inner.forEach((error) => {
          formError.value[error.path] = error.message;
        });
      }
    };

    return {
      formData,
      formError,
      messageError,
      schemaForm,
      onChangePassword,
    };
  },
};
</script>

<style lang="scss" scoped>
.change-password {
  text-align: center;
}
input.error {
  border-color: #faa;
  background-color: #ffeded;
}

button {
  margin: 20px 0 0 0;
}
button:hover {
  background-color: #3ab025;
}

.field {
  margin-top: 15px;
  margin-bottom: 5px;
}
</style>
